#!/bin/bash -e

function predict() {
  FILE="$1"
  AGE="$2"
  perl -ne "BEGIN { \$age = $AGE; }"' chomp; die $_ unless /prediction:\s+([\d.]+)(?:\s+cut point:\s+([\d.]+))?/; if (!$2 || $age <= $2) { print "$1\n"; exit; }' "$FILE"
}

./predict.sh
for SEX in male female; do
  (
    echo "age underweight normal overweight obese"
    for AGE in {17..90}; do
      REFERENCE=$(predict $SEX.model $AGE)
      echo -n "$AGE"
      for WEIGHTCLASS in underweight normal overweight obese; do
        ACTUAL=$(predict $SEX.$WEIGHTCLASS.model $AGE)
        EXCESS=$(echo "$ACTUAL - $REFERENCE" | bc)
        echo -n " $EXCESS"
      done
      echo
    done
  )> "$SEX.excess"
done
